# coding: utf-8

"""
    Flat API

    The Flat API allows you to easily extend the abilities of the [Flat Platform](https://flat.io), with a wide range of use cases including the following:  * Creating and importing new music scores using MusicXML or MIDI files * Browsing, updating, copying, exporting the user's scores (for example in MP3, WAV or MIDI) * Managing educational resources with Flat for Education: creating & updating the organization accounts, the classes, rosters and assignments.  The Flat API is built on HTTP. Our API is RESTful It has predictable resource URLs. It returns HTTP response codes to indicate errors. It also accepts and returns JSON in the HTTP body. The [schema](/swagger.yaml) of this API follows the [OpenAPI Initiative (OAI) specification](https://www.openapis.org/), you can use and work with [compatible Swagger tools](http://swagger.io/open-source-integrations/). This API features Cross-Origin Resource Sharing (CORS) implemented in compliance with [W3C spec](https://www.w3.org/TR/cors/).  You can use your favorite HTTP/REST library for your programming language to use Flat's API. This specification and reference is [available on Github](https://github.com/FlatIO/api-reference).  Getting Started and learn more:  * [API Overview and interoduction](https://flat.io/developers/docs/api/) * [Authentication (Personal Access Tokens or OAuth2)](https://flat.io/developers/docs/api/authentication.html) * [SDKs](https://flat.io/developers/docs/api/sdks.html) * [Rate Limits](https://flat.io/developers/docs/api/rate-limits.html) * [Changelog](https://flat.io/developers/docs/api/changelog.html) 

    OpenAPI spec version: 2.2.0
    Contact: developers@flat.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

# import models into model package
from .assignment import Assignment
from .assignment_copy import AssignmentCopy
from .assignment_creation import AssignmentCreation
from .assignment_submission import AssignmentSubmission
from .assignment_submission_update import AssignmentSubmissionUpdate
from .class_attachment_creation import ClassAttachmentCreation
from .class_creation import ClassCreation
from .class_details import ClassDetails
from .class_details_canvas import ClassDetailsCanvas
from .class_details_google_classroom import ClassDetailsGoogleClassroom
from .class_details_google_drive import ClassDetailsGoogleDrive
from .class_details_lti import ClassDetailsLti
from .class_roles import ClassRoles
from .class_state import ClassState
from .class_stream_post_mode import ClassStreamPostMode
from .class_update import ClassUpdate
from .flat_error_response import FlatErrorResponse
from .flat_locales import FlatLocales
from .google_classroom_coursework import GoogleClassroomCoursework
from .google_classroom_submission import GoogleClassroomSubmission
from .group import Group
from .group_details import GroupDetails
from .group_type import GroupType
from .license_mode import LicenseMode
from .license_sources import LicenseSources
from .lms_name import LmsName
from .lti_credentials import LtiCredentials
from .lti_credentials_creation import LtiCredentialsCreation
from .media_attachment import MediaAttachment
from .media_score_sharing_mode import MediaScoreSharingMode
from .organization_invitation import OrganizationInvitation
from .organization_invitation_creation import OrganizationInvitationCreation
from .organization_roles import OrganizationRoles
from .score_collaborator import ScoreCollaborator
from .score_collaborator_creation import ScoreCollaboratorCreation
from .score_comment import ScoreComment
from .score_comment_context import ScoreCommentContext
from .score_comment_creation import ScoreCommentCreation
from .score_comment_update import ScoreCommentUpdate
from .score_comments_counts import ScoreCommentsCounts
from .score_creation import ScoreCreation
from .score_data import ScoreData
from .score_data_encoding import ScoreDataEncoding
from .score_fork import ScoreFork
from .score_likes_counts import ScoreLikesCounts
from .score_modification import ScoreModification
from .score_privacy import ScorePrivacy
from .score_revision import ScoreRevision
from .score_revision_creation import ScoreRevisionCreation
from .score_revision_statistics import ScoreRevisionStatistics
from .score_rights import ScoreRights
from .score_source import ScoreSource
from .score_summary import ScoreSummary
from .score_views_counts import ScoreViewsCounts
from .user_basics import UserBasics
from .user_creation import UserCreation
from .user_details_admin_license import UserDetailsAdminLicense
from .score_details import ScoreDetails
from .user_public_summary import UserPublicSummary
from .user_details_admin import UserDetailsAdmin
from .user_public import UserPublic
from .user_details import UserDetails
