# coding: utf-8

"""
    Flat API

    The Flat API allows you to easily extend the abilities of the [Flat Platform](https://flat.io), with a wide range of use cases including the following:  * Creating and importing new music scores using MusicXML or MIDI files * Browsing, updating, copying, exporting the user's scores (for example in MP3, WAV or MIDI) * Managing educational resources with Flat for Education: creating & updating the organization accounts, the classes, rosters and assignments.  The Flat API is built on HTTP. Our API is RESTful It has predictable resource URLs. It returns HTTP response codes to indicate errors. It also accepts and returns JSON in the HTTP body. The [schema](/swagger.yaml) of this API follows the [OpenAPI Initiative (OAI) specification](https://www.openapis.org/), you can use and work with [compatible Swagger tools](http://swagger.io/open-source-integrations/). This API features Cross-Origin Resource Sharing (CORS) implemented in compliance with [W3C spec](https://www.w3.org/TR/cors/).  You can use your favorite HTTP/REST library for your programming language to use Flat's API. This specification and reference is [available on Github](https://github.com/FlatIO/api-reference).  Getting Started and learn more:  * [API Overview and interoduction](https://flat.io/developers/docs/api/) * [Authentication (Personal Access Tokens or OAuth2)](https://flat.io/developers/docs/api/authentication.html) * [SDKs](https://flat.io/developers/docs/api/sdks.html) * [Rate Limits](https://flat.io/developers/docs/api/rate-limits.html) * [Changelog](https://flat.io/developers/docs/api/changelog.html) 

    OpenAPI spec version: 2.2.0
    Contact: developers@flat.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class UserPublic(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'username': 'str',
        'name': 'str',
        'printable_name': 'str',
        'picture': 'str',
        'is_power_user': 'bool',
        'organization': 'str',
        'organization_role': 'OrganizationRoles',
        'class_role': 'ClassRoles',
        'html_url': 'str',
        'bio': 'str',
        'registration_date': 'datetime',
        'liked_scores_count': 'int',
        'followers_count': 'int',
        'following_count': 'int',
        'owned_public_scores_count': 'int'
    }

    attribute_map = {
        'id': 'id',
        'username': 'username',
        'name': 'name',
        'printable_name': 'printableName',
        'picture': 'picture',
        'is_power_user': 'isPowerUser',
        'organization': 'organization',
        'organization_role': 'organizationRole',
        'class_role': 'classRole',
        'html_url': 'htmlUrl',
        'bio': 'bio',
        'registration_date': 'registrationDate',
        'liked_scores_count': 'likedScoresCount',
        'followers_count': 'followersCount',
        'following_count': 'followingCount',
        'owned_public_scores_count': 'ownedPublicScoresCount'
    }

    def __init__(self, id=None, username=None, name=None, printable_name=None, picture=None, is_power_user=None, organization=None, organization_role=None, class_role=None, html_url=None, bio=None, registration_date=None, liked_scores_count=None, followers_count=None, following_count=None, owned_public_scores_count=None):
        """
        UserPublic - a model defined in Swagger
        """

        self._id = None
        self._username = None
        self._name = None
        self._printable_name = None
        self._picture = None
        self._is_power_user = None
        self._organization = None
        self._organization_role = None
        self._class_role = None
        self._html_url = None
        self._bio = None
        self._registration_date = None
        self._liked_scores_count = None
        self._followers_count = None
        self._following_count = None
        self._owned_public_scores_count = None

        if id is not None:
          self.id = id
        if username is not None:
          self.username = username
        if name is not None:
          self.name = name
        if printable_name is not None:
          self.printable_name = printable_name
        if picture is not None:
          self.picture = picture
        if is_power_user is not None:
          self.is_power_user = is_power_user
        if organization is not None:
          self.organization = organization
        if organization_role is not None:
          self.organization_role = organization_role
        if class_role is not None:
          self.class_role = class_role
        if html_url is not None:
          self.html_url = html_url
        if bio is not None:
          self.bio = bio
        if registration_date is not None:
          self.registration_date = registration_date
        if liked_scores_count is not None:
          self.liked_scores_count = liked_scores_count
        if followers_count is not None:
          self.followers_count = followers_count
        if following_count is not None:
          self.following_count = following_count
        if owned_public_scores_count is not None:
          self.owned_public_scores_count = owned_public_scores_count

    @property
    def id(self):
        """
        Gets the id of this UserPublic.
        The user unique identifier

        :return: The id of this UserPublic.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this UserPublic.
        The user unique identifier

        :param id: The id of this UserPublic.
        :type: str
        """

        self._id = id

    @property
    def username(self):
        """
        Gets the username of this UserPublic.
        The user name (unique for the organization)

        :return: The username of this UserPublic.
        :rtype: str
        """
        return self._username

    @username.setter
    def username(self, username):
        """
        Sets the username of this UserPublic.
        The user name (unique for the organization)

        :param username: The username of this UserPublic.
        :type: str
        """

        self._username = username

    @property
    def name(self):
        """
        Gets the name of this UserPublic.
        A displayable name for the user

        :return: The name of this UserPublic.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this UserPublic.
        A displayable name for the user

        :param name: The name of this UserPublic.
        :type: str
        """

        self._name = name

    @property
    def printable_name(self):
        """
        Gets the printable_name of this UserPublic.
        The name that can be directly printed (name or username)

        :return: The printable_name of this UserPublic.
        :rtype: str
        """
        return self._printable_name

    @printable_name.setter
    def printable_name(self, printable_name):
        """
        Sets the printable_name of this UserPublic.
        The name that can be directly printed (name or username)

        :param printable_name: The printable_name of this UserPublic.
        :type: str
        """

        self._printable_name = printable_name

    @property
    def picture(self):
        """
        Gets the picture of this UserPublic.
        User pictue

        :return: The picture of this UserPublic.
        :rtype: str
        """
        return self._picture

    @picture.setter
    def picture(self, picture):
        """
        Sets the picture of this UserPublic.
        User pictue

        :param picture: The picture of this UserPublic.
        :type: str
        """

        self._picture = picture

    @property
    def is_power_user(self):
        """
        Gets the is_power_user of this UserPublic.
        User license status. 'True' if user is an individual Power user

        :return: The is_power_user of this UserPublic.
        :rtype: bool
        """
        return self._is_power_user

    @is_power_user.setter
    def is_power_user(self, is_power_user):
        """
        Sets the is_power_user of this UserPublic.
        User license status. 'True' if user is an individual Power user

        :param is_power_user: The is_power_user of this UserPublic.
        :type: bool
        """

        self._is_power_user = is_power_user

    @property
    def organization(self):
        """
        Gets the organization of this UserPublic.
        Organization ID (for Edu users only)

        :return: The organization of this UserPublic.
        :rtype: str
        """
        return self._organization

    @organization.setter
    def organization(self, organization):
        """
        Sets the organization of this UserPublic.
        Organization ID (for Edu users only)

        :param organization: The organization of this UserPublic.
        :type: str
        """

        self._organization = organization

    @property
    def organization_role(self):
        """
        Gets the organization_role of this UserPublic.

        :return: The organization_role of this UserPublic.
        :rtype: OrganizationRoles
        """
        return self._organization_role

    @organization_role.setter
    def organization_role(self, organization_role):
        """
        Sets the organization_role of this UserPublic.

        :param organization_role: The organization_role of this UserPublic.
        :type: OrganizationRoles
        """

        self._organization_role = organization_role

    @property
    def class_role(self):
        """
        Gets the class_role of this UserPublic.

        :return: The class_role of this UserPublic.
        :rtype: ClassRoles
        """
        return self._class_role

    @class_role.setter
    def class_role(self, class_role):
        """
        Sets the class_role of this UserPublic.

        :param class_role: The class_role of this UserPublic.
        :type: ClassRoles
        """

        self._class_role = class_role

    @property
    def html_url(self):
        """
        Gets the html_url of this UserPublic.
        Link to user profile (for Indiv. users only)

        :return: The html_url of this UserPublic.
        :rtype: str
        """
        return self._html_url

    @html_url.setter
    def html_url(self, html_url):
        """
        Sets the html_url of this UserPublic.
        Link to user profile (for Indiv. users only)

        :param html_url: The html_url of this UserPublic.
        :type: str
        """

        self._html_url = html_url

    @property
    def bio(self):
        """
        Gets the bio of this UserPublic.
        User's biography

        :return: The bio of this UserPublic.
        :rtype: str
        """
        return self._bio

    @bio.setter
    def bio(self, bio):
        """
        Sets the bio of this UserPublic.
        User's biography

        :param bio: The bio of this UserPublic.
        :type: str
        """

        self._bio = bio

    @property
    def registration_date(self):
        """
        Gets the registration_date of this UserPublic.
        Date the user signed up

        :return: The registration_date of this UserPublic.
        :rtype: datetime
        """
        return self._registration_date

    @registration_date.setter
    def registration_date(self, registration_date):
        """
        Sets the registration_date of this UserPublic.
        Date the user signed up

        :param registration_date: The registration_date of this UserPublic.
        :type: datetime
        """

        self._registration_date = registration_date

    @property
    def liked_scores_count(self):
        """
        Gets the liked_scores_count of this UserPublic.
        Number of the scores liked by the user

        :return: The liked_scores_count of this UserPublic.
        :rtype: int
        """
        return self._liked_scores_count

    @liked_scores_count.setter
    def liked_scores_count(self, liked_scores_count):
        """
        Sets the liked_scores_count of this UserPublic.
        Number of the scores liked by the user

        :param liked_scores_count: The liked_scores_count of this UserPublic.
        :type: int
        """

        self._liked_scores_count = liked_scores_count

    @property
    def followers_count(self):
        """
        Gets the followers_count of this UserPublic.
        Number of followers the user have

        :return: The followers_count of this UserPublic.
        :rtype: int
        """
        return self._followers_count

    @followers_count.setter
    def followers_count(self, followers_count):
        """
        Sets the followers_count of this UserPublic.
        Number of followers the user have

        :param followers_count: The followers_count of this UserPublic.
        :type: int
        """

        self._followers_count = followers_count

    @property
    def following_count(self):
        """
        Gets the following_count of this UserPublic.
        Number of people the user follow

        :return: The following_count of this UserPublic.
        :rtype: int
        """
        return self._following_count

    @following_count.setter
    def following_count(self, following_count):
        """
        Sets the following_count of this UserPublic.
        Number of people the user follow

        :param following_count: The following_count of this UserPublic.
        :type: int
        """

        self._following_count = following_count

    @property
    def owned_public_scores_count(self):
        """
        Gets the owned_public_scores_count of this UserPublic.
        Number of public score the user have

        :return: The owned_public_scores_count of this UserPublic.
        :rtype: int
        """
        return self._owned_public_scores_count

    @owned_public_scores_count.setter
    def owned_public_scores_count(self, owned_public_scores_count):
        """
        Sets the owned_public_scores_count of this UserPublic.
        Number of public score the user have

        :param owned_public_scores_count: The owned_public_scores_count of this UserPublic.
        :type: int
        """

        self._owned_public_scores_count = owned_public_scores_count

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, UserPublic):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
